commit e5e4e60376e679474ebb5e4ef2ff13b7d60bc4ce
Author: jklowden <jklowden>
Date:   Sat Dec 27 21:48:36 2008 +0000

    different approach to Win32 compatibility

diff --git a/ChangeLog b/ChangeLog
index fe597fe..7029d9b 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Sat Dec 27 16:47:40 EST 2008	JK Lowden <jklowden@freetds.org>
+	* src/replacements/fakepoll.c src/replacements/fakepoll.h
+	- different approach to Win32 compatibility
+
 Fri Dec 26 13:20:39 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/blob1.c: cleanup
 
@@ -1147,4 +1151,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2700 2008/12/26 12:20:50 freddy77 Exp $
+$Id: ChangeLog,v 1.2701 2008/12/27 21:48:36 jklowden Exp $
diff --git a/src/replacements/fakepoll.c b/src/replacements/fakepoll.c
index e48cd58..14a1df6 100644
--- a/src/replacements/fakepoll.c
+++ b/src/replacements/fakepoll.c
@@ -18,7 +18,7 @@
  * Converted to C and spruced up by James K. Lowden December 2008. 
  */
 
-static char software_version[] = "$Id: fakepoll.c,v 1.2 2008/12/20 19:11:54 freddy77 Exp $";
+static char software_version[] = "$Id: fakepoll.c,v 1.3 2008/12/27 21:48:36 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #include "fakepoll.h"
@@ -79,10 +79,8 @@ fakepoll(struct pollfd fds[], int nfds, int timeout)
 			continue;
 		} 
 
-#if !defined(WIN32)
 		if (p->fd > maxfd)
 			maxfd = p->fd;
-#endif
 
 		/* POLLERR is never set coming in; poll(2) always reports errors */
 		/* But don't report if we're not listening to anything at all. */
@@ -94,7 +92,10 @@ fakepoll(struct pollfd fds[], int nfds, int timeout)
 			FD_SET(p->fd, &fdsp);
 	}
 
-#if !defined(WIN32)
+#if defined(WIN32)
+	/* Win32 cares about the number of desciptors, not the highest one. */
+	maxfd = nfds;
+#endif
 	/* 
 	 * If any FD is too big for select(2), we need to return an error. 
 	 * Which one, though, is debatable.  There's no defined errno for 
@@ -108,7 +109,6 @@ fakepoll(struct pollfd fds[], int nfds, int timeout)
 		errno = EINVAL;
 		return -1;
 	}
-#endif
 
 	/*
 	 * poll timeout is in milliseconds. Convert to struct timeval.
diff --git a/src/replacements/fakepoll.h b/src/replacements/fakepoll.h
index d40518d..569b485 100644
--- a/src/replacements/fakepoll.h
+++ b/src/replacements/fakepoll.h
@@ -1,4 +1,4 @@
-/* $Id: fakepoll.h,v 1.1 2008/12/20 06:01:47 jklowden Exp $ */
+/* $Id: fakepoll.h,v 1.2 2008/12/27 21:48:36 jklowden Exp $ */
 #if !defined(_FAKE_POLL_H) && !defined(HAVE_POLL)
 #define _FAKE_POLL_H
 
@@ -15,6 +15,10 @@
 #include <sys/select.h>
 #endif 
 
+#if defined(WIN32)
+#include <winsock2.h>
+#endif
+
 #if !defined(FD_SETSIZE)
 # if !defined(OPEN_MAX)
 # error cannot establish FD_SETSIZE

